REM a Classic Cards Solitaire game @Cassiope34 0517

Fn.def clc(n)    % card color   1=clover, 2=spade, 3=heart, 4=diamond
 Fn.rtn int(n/13.1)+1
Fn.end

Fn.def vlc(n)    % card value
 noc =mod(n,13) : noc+=13*(noc=0) : Fn.rtn noc
Fn.end

Fn.def LastPtr( ptr )  % puts the graphic pointer 'ptr' above all others (and so always visible).
  gr.getDL ndl[],1
  array.length sz, ndl[]
  if !ptr | sz=1 | ndl[sz] =ptr then array.delete ndl[] : Fn.rtn 0
  array.search ndl[],ptr,n
  if n
    for nn=n to sz-1 : ndl[nn] =ndl[nn+1] : next
    ndl[sz] =ptr : gr.newDL ndl[]
  endif
  array.delete ndl[]
Fn.end

Fn.def move2(ptr, arx, ary, pas)   % move smoothly the bitmap 'ptr' to arx,ary  (with 'pas' around 12 pixels)
LastPtr( ptr )
if pas>1
  gr.get.position ptr,dpx,dpy
  ex =int((arx-dpx)/pas) : ey =int((ary-dpy)/pas)
  for e=1 to pas-1 : gr.move ptr, ex, ey : gr.render : next
endif
gr.modify ptr, "x",arx, "y",ary : gr.render
Fn.end

FN.DEF RectR(x,y, c, lx,ly, fill)     %  make rectangle with rounded corners.
GR.ARC nul, x, y, x+c, y+c, -90, -90, fill     % top left
GR.ARC nul, x+lx-c,y, x+lx, y+c, -90, 90, fill   % top right
GR.ARC nul, x, y+ly-c,x+c, y+ly, -180, -90, fill   % bottom left
GR.ARC nul, x+lx-c, y+ly-c, x+lx, y+ly, 0, 90, fill  % bottom right
if !fill
  GR.LINE r1, x+c/2, y, x+lx-c/2, y     % left
  GR.LINE r2, x, y+c/2, x, y+ly-c/2     % up
  GR.LINE r3, x+c/2, y+ly, x+lx-c/2, y+ly  % right
  GR.LINE r4, x+lx, y+c/2, x+lx, y+ly-c/2  % down
else
  c*=0.4
  gr.rect nul, x+c, y, x+lx-c, y+ly
  gr.rect nul, x, y+c, x+lx, y+ly-c
endif
FN.END

gr.open 255,84,140,78,0,1   % kind of green
gr.screen w,h
scx = 800
scy = 1280
sx  = w/scx
sy  = h/scy
gr.scale sx,sy

File.Root tmp$
IstandAlone =Is_In("rfo-basic",tmp$)    % to know if it's an APK for the way to exit
path$ =""
filename$ ="CardSolitaire.sav"
gr.bitmap.load bmps, path$ + "52_cards.png"
Font.load ft, path$ + "Batavia.TTF"
gr.text.setFont ft
ncp =52 : ctx =110 : cty =155 : inc =50
DIM bc[ncp], dos[6], p[ncp,2], v[ncp,2], as[4,13,2], na[4], co[7,20,3], n[7]
pt =1  % graphic pointer
vl =2  % value  1-52
vu =3  % visible
bdos =1
start =1

GOSUB MakeCards   % make 52 cards bitmaps by crops...

DO
  np =ncp   % nombre de cartes actuellement ds le paquet.
  nv =0     % nombre de cartes actuellement visible à gauche du paquet.
  array.fill p[],0  : array.fill co[],0 : array.fill n[],0
  array.fill as[],0 : array.fill na[],0 : array.fill v[],0
  
  GOSUB InitGame
  new =0 : fin =0
  
  DO
    do
      gr.touch touched,tx,ty
      if !background() then gr.render
    until touched | quit | new
    if quit | new then d_u.break
    tx/=sx : ty/=sy
    cx =int(tx/114)+1 : cy =int((ty-gy)/inc)+1 : carte$ ="" : mv =0 : ht =0 : as =0 : cc =0 : vc =0
    
    if cy>0         % prise ds les colonnes
      if n[cx] & cy<n[cx]+3
        ny =min(cy,n[cx])  % dernière carte si touché trop bas ds la colonne...
        if co[cx,ny,vu]      % une carte visible
          for c=ny to n[cx] : LastPtr( co[cx,c,pt] ) : next
          orx =2+(cx-1)*114 : ory =gy+(ny-1)*inc : deltaX= tx-orx : deltaY= ty-ory : mv =1
          cc =clc( co[cx,ny,vl] ) : vc =vlc( co[cx,ny,vl] )
        endif
        
      endif
      
    elseif cy<1 & cy>-3          % pris en haut
      if cx=5 | cx=6     % la carte de la pile des cartes visibles ( retournées )
        if nv
          LastPtr( v[nv,pt] ) : orx =vx : ory =vy : deltaX= tx-orx : deltaY= ty-ory : mv =1 : ht =1
          cc =clc( v[nv,vl] ) : vc =vlc( v[nv,vl] )
        endif
    
      elseif cx=7   % retourne la carte du paquet si possible sinon le reconstitue avec v[]
        if np
          move2(p[np,pt], vx, vy, 2) : nv++         % retourne la carte du paquet.
          swap p[np,pt], v[nv,pt] : swap p[np,vl], v[nv,vl] : np--
          gr.modify v[nv,pt], "bitmap", bc[v[nv,vl]]  
          
        else
          for c=nv to 1 step -1                     % re-fabrique le paquet
            gr.modify v[c,pt], "bitmap", dos[bdos]
            move2(v[c,pt], pqx, pqy, 2) : np++
            swap p[np,pt], v[c,pt] : swap p[np,vl], v[c,vl] : nv--
          next
          
        endif
    
      elseif cx<5   % on peut vouloir récupérer une carte déjà posée sur les AS...
        if na[cx]
          LastPtr( as[cx,na[cx],pt] ) : orx =18+(cx-1)*120 : ory =pqy-2 : deltaX= tx-orx : deltaY= ty-ory
          cc =clc( as[cx,na[cx],vl] ) : vc =vlc( as[cx,na[cx],vl] ) : mv =1 : ht =1 : as =1
        endif
    
      endif
      
    endif
    if fin then mv =0
    
    do
      gr.touch touched,x,y : x/=sx : y/=sy
      if mv
        if !ht
          nc =0 : for c=ny to n[cx] : gr.modify co[cx,c,pt], "x", x-deltaX, "y", y-deltaY+nc*inc : nc++ : next
        else
          if !as
            gr.modify v[nv,pt], "x", x-deltaX, "y", y-deltaY
          else
            gr.modify as[cx,na[cx],pt], "x", x-deltaX, "y", y-deltaY
          endif
        endif
        gr.render
      endif
    until !touched
    ax =int(x/114)+1 : ay =int((y-gy)/inc)+1 : ok =0 : cs =0
    
    if !mv & ay<-3
      GOSUB ChangeDos
      
    elseif mv
      if ax=cx & ay=cy & !ht & ny<n[cx]     % même endroit : automatique avec plusieures cartes...
        cs =2 : goto plus
        
      elseif ax=cx & ay=cy & (ht | ny=n[cx])     % même endroit : automatique avec 1 seule carte.
        goto auto
        
      elseif ay>0     % laché ds les colonnes
        if n[ax]
          ccc =clc( co[ax,n[ax],vl] ) : vcc =vlc( co[ax,n[ax],vl] )
          if ((ccc<3 & cc>2) | (cc<3 & ccc>2)) & vcc-vc=1   % si elle peut aller là
            orx =2+(ax-1)*114 : ory =gy+n[ax]*inc : ok =1   % dernière place de la colonne.
          endif
          
        else
          if vc=13 then orx =2+(ax-1)*114 : ory =gy : ok =1   % première place de la colonne = Roi.
          
        endif
        
      elseif ax<5 & (ht | ny=n[cx])    % un seule carte lachée sur les AS en haut ou ds les colonnes...
        auto:
        pc =val(mid$("3124",cc,1))     % 1-4 place de cette couleur en haut (AS).
        if as & n[ax]
          ccc =clc( co[ax,n[ax],vl] ) : vcc =vlc( co[ax,n[ax],vl] )
          if ((ccc<3 & cc>2) | (cc<3 & ccc>2)) & vcc-vc=1   % si elle peut aller là
            orx =2+(ax-1)*114 : ory =gy+n[ax]*inc : ok =1   % dernière place de la colonne.
          endif          
        elseif na[pc]
          if vc-vlc(as[pc,na[pc],vl])=1 then ok =2    % sur une pile des AS en haut.
        elseif vc =1
          ok =2
        endif
        plus:
        if !ok
          for c=1 to 7    %  recherche une place possible...
            if n[c]
              ccc =clc( co[c,n[c],vl] ) : vcc =vlc( co[c,n[c],vl] )
              if ((ccc<3 & cc>2) | (cc<3 & ccc>2)) & vcc-vc=1   % si elle peut aller là
                orx =2+(c-1)*114 : ory =gy+n[c]*inc : ax =c : ok =3-cs : F_n.break   % dernière place de la colonne.
              endif
            else
              if vc=13 then orx =2+(c-1)*114 : ory =gy : ax =c : ok =3-cs : F_n.break  % première place  (Roi).
            endif
          next
        endif
        if ok=2 then orx =18+(pc-1)*120 : ory =pqy-2     % sur les AS en haut
      endif

      if !ht       %  vient des colonnes.
        gr.get.position co[cx,ny,pt], dx,dy : pas =2
        ex =int((orx-dx)/pas) : ey =int((ory-dy)/pas)
        for e=1 to pas-1 : for c=ny to n[cx] : gr.move co[cx,c,pt], ex, ey : next : gr.render : next
        nc =0 : for c=ny to n[cx] : gr.modify co[cx,c,pt], "x", orx, "y", ory+nc*inc : nc++ : next
        gr.render
        
        if ok     % on met à jour les variables des colonnes...
          if ok =1
            for c=ny to n[cx]
              n[ax]++ : swap co[cx,c,pt], co[ax,n[ax],pt] : swap co[cx,c,vl], co[ax,n[ax],vl]
              swap co[cx,c,vu], co[ax,n[ax],vu] : n[cx]--
            next
          elseif ok=2
            na[pc]++ : swap as[pc,na[pc],pt], co[cx,n[cx],pt] : swap as[pc,na[pc],vl], co[cx,n[cx],vl] : n[cx]--
          elseif ok=3
            n[ax]++ : swap co[ax,n[ax],pt], co[cx,n[cx],pt] : swap co[ax,n[ax],vl], co[cx,n[cx],vl]
            swap co[cx,n[cx],vu], co[ax,n[ax],vu] : n[cx]--
          endif
          if n[cx]     % retourne la carte de la colonne d'origine.
            if co[cx,n[cx],vu]=0 then co[cx,n[cx],vu] =1 : gr.modify co[cx,n[cx],pt], "bitmap", bc[co[cx,n[cx],vl]]
          endif
        
        endif

      else          % vient d'au dessus des colonnes.
        if !as
          move2(v[nv,pt], orx, ory, 2)     % et de la pile des cartes retournées...
          if ok=1
            n[ax]++ : swap co[ax,n[ax],pt], v[nv,pt] : swap co[ax,n[ax],vl], v[nv,vl] : co[ax,n[ax],vu] =1 : nv--
          elseif ok=2
            na[pc]++ : swap as[pc,na[pc],pt], v[nv,pt] : swap as[pc,na[pc],vl], v[nv,vl] : nv--
          elseif ok=3
            n[ax]++ : swap co[ax,n[ax],pt], v[nv,pt] : swap co[ax,n[ax],vl], v[nv,vl] : co[ax,n[ax],vu] =1 : nv--
          endif
          
        else         % c'est une carte qui vient d'une pile des AS.
          move2(as[cx,na[cx],pt], orx, ory, 2)
          if ok
            n[ax]++ : swap co[ax,n[ax],pt], as[cx,na[cx],pt] : swap co[ax,n[ax],vl], as[cx,na[cx],vl]
            co[ax,n[ax],vu] =1 : na[cx]--
          endif
        
        endif
        
      endif
      gosub CtrlFin
    
    endif

  UNTIL new
UNTIL quit
GOSUB SaveGame
if IstandAlone then END "Bye!"
EXIT

OnBackKey:
  Dialog.message win$,"       What do you want ?", ok, " Exit ", " New Game ? ", " Cancel "
  new  =(ok=2) : quit =(ok=1)
back.resume

CtrlFin:
if nv+np=0 : fin =1   %  si pas de cartes sur un des 2 paquets en haut à droite, 
  for c1=1 to 7       %  et pas de carte cachée ds une colonne...
    if n[c1]
      for c2=1 to n[c1]
        if !co[c1,c2,vu] then fin =0 : f_n.break
      next
    endif
    if !fin then f_n.break
  next
endif
if fin       %  ramène toutes les cartes sur les AS.
  do
    for a=1 to 4
      if na[a]<13
        v =vlc(as[a,na[a],vl]) : cc =clc(as[a,na[a],vl])
        for c=1 to 7
          if n[c]
            vv =vlc(co[c,n[c],vl]) : ccc =clc(co[c,n[c],vl])
            if ccc=cc & vv=v+1 : move2(co[c,n[c],pt], 18+(a-1)*120, pqy-2, 4)
              na[a]++ : swap co[c,n[c],pt], as[a,na[a],pt] : swap co[c,n[c],vl], as[a,na[a],vl] : n[c]--
            endif
          endif
        next
      endif
    next
  until na[1]+na[2]+na[3]+na[4]=52
endif
return

MakeCards:
dcx =158 : dcy =246
gr.set.stroke 1
for c=1 to ncp         %  all cards bitmaps.
  cc =clc(c) : vc =vlc(c)
  gr.bitmap.crop nul, bmps, (vc-1)*dcx+6, (cc-1)*dcy+6, dcx-12, dcy-12
  gr.bitmap.scale nul1, nul, ctx-12, cty-12 : gr.bitmap.delete nul
  gr.bitmap.create bc[c], ctx, cty  % crée la carte
  gr.bitmap.drawinto.start bc[c]
  gr.color 255,0,0,0,0          % cadre noir
  RectR(0,0, 30, ctx, cty, 0)
  gr.color 255,255,255,255,1    % fond blanc
  RectR(1,1, 28, ctx-2, cty-2, 1)
  gr.bitmap.draw nul2, nul1, 6,6   % copie la carte
next
for d=1 to 6
  gr.bitmap.crop nul, bmps, (d-1)*dcx+6, 4*dcy+6, dcx-12, dcy-12
  gr.bitmap.scale nul1, nul, ctx-12, cty-12 : gr.bitmap.delete nul
  gr.bitmap.create dos[d], ctx, cty
  gr.bitmap.drawinto.start dos[d]
  gr.color 255,0,0,0,0
  RectR(0,0, 30, ctx, cty, 0)
  gr.color 255,255,255,255,1
  RectR(1,1, 28, ctx-2, cty-2, 1)
  gr.bitmap.draw nul2, nul1, 6,6
next
gr.bitmap.drawinto.end
gr.bitmap.crop carro, bmps, 1598,1114, 108,111    % crop cards color
gr.bitmap.crop pique, bmps, 1445,1114, 108,111
gr.bitmap.crop coeur, bmps, 1598,0998, 108,111
gr.bitmap.crop trefl, bmps, 1445,0998, 108,111
gr.bitmap.delete bmps     % free memory of the original .png file.
return

ChangeDos:
bdos =bdos+1-6*(bdos=6)
if np then for c=1 to np : gr.modify p[c,pt], "bitmap", dos[bdos] : next
for cox=1 to 7
  if n[cox]
    for coy=1 to n[cox]
      if !co[cox,coy,vu] then gr.modify co[cox,coy,pt], "bitmap", dos[bdos]
    next
  endif
next
return

InitGame:
GR.CLS
gx  =(scx-3*(dcx+20))/2
gy  =1.4*dcy
pqx =scx-125  :  pqy =160    % position du paquet
vx  =5*114-20 :  vy  =pqy    %    "     de la pile découverte.
gr.color 255,110,185,102,1   % light green
for as=0 to 3 : RectR(16+as*120,pqy-5, 30, 114, 160, 1) : next
RectR(pqx-2,pqy-2, 30, 114, 160, 1)
gr.set.stroke 4 : gr.color 255,84,140,78,0 : for cr=1 to 8 : gr.circle nul, pqx+52, pqy+77, 30+cr : next
gr.color 80
gr.bitmap.draw nul, pique, 19+0*120, pqy+20
gr.bitmap.draw nul, coeur, 19+1*120, pqy+20   % places for Aces.
gr.bitmap.draw nul, trefl, 19+2*120, pqy+20
gr.bitmap.draw nul, carro, 19+3*120, pqy+20
gr.color 80,200,200,200,1  : gr.rect nul, 80, 30, scx-80, 110
gr.color 255,84,140,78,1   : gr.circle nul, 90,70,40  :  gr.circle nul, scx-90,70,40
gr.color 100,200,200,200,1 : gr.circle nul, 70,70,40  :  gr.circle nul, scx-70,70,40
gr.color 255, 255, 255, 0, 2
gr.set.stroke 2 : gr.text.size 45 : gr.text.align 2
gr.text.draw nul, scx/2, 88, "S o l i t a i r e"

file.exists fe, path$+filename$
if fe & start
  GOSUB LoadGame : start =0
else
  ch$ ="" : t =0     %  paquet
  for c=1 to ncp     %  make & shuffle the deck :52 graphicals objects with the 'back' bitmap.
    do : n =int(rnd()*ncp)+1 : until !IS_IN(format$("%%",n),ch$)    %  unique...
    ch$+=format$("%%",n) : p[c,vl] =n-ncp*(n>ncp) : t+=0.33
    gr.bitmap.draw p[c,pt], dos[bdos], pqx+t, pqy-t
  next
  np =ncp : nbc =0         % distrib. 7 colonnes
  for co=1 to 7
    dy =1 : cx =2+(co-1)*114 : nbc++ : n[co] =nbc
    for c =1 to nbc
      cy =gy +(dy-1)*inc :dy++ : move2( p[np,pt], cx, cy, 0)
      if c<nbc then nbmp =dos[bdos] else nbmp =bc[p[np,vl]] : co[co,c,vu] =1
      gr.modify p[np,pt], "bitmap", nbmp    % dos ou carte
      swap co[co,c,pt], p[np,pt] : swap co[co,c,vl], p[np,vl]
      np--
    next
  next
endif
RETURN

SaveGame:
CLS : ?bdos
for c=1 to 4       % les piles des AS
  c$ =""
  if na[c] then for n=1 to na[c] : c$+=format$("##",as[c,n,vl]) : next
  ?c$
next
c$ ="" : if nv then for n=1 to nv : c$+=format$("##",v[n,vl]) : next   % pile cartes visible
?c$
c$ ="" : if np then for n=1 to np : c$+=format$("##",p[n,vl]) : next   % le paquet
?c$
for c=1 to 7       % les colonnes
  c$ =" "
  if n[c]
    for n=1 to n[c] : c$+=format$("##",co[c,n,vl])+" "+int$(co[c,n,vu]) : next
  endif
  ?c$
next
Console.Save path$+filename$ : CLS
return

LoadGame:
np =0 : nv =0
GRABFILE ldg$, path$+filename$
split ln$[], ldg$, "\n"
bdos =val(ln$[1])
for c=1 to 4       % les piles des AS
  if len(ln$[1+c]) : cr =1
    do
      c$ =word$(ln$[1+c], cr)
      if len(c$) then as[c,cr,vl] =val(c$) : gr.bitmap.draw as[c,cr,pt], bc[as[c,cr,vl]], 18+(c-1)*120, pqy-2 : na[c]++ : cr++
    until c$=""
  endif
next
if len(ln$[6]) : cr =1
  do
    c$ =word$(ln$[6], cr)
    if len(c$) then v[cr,vl] =val(c$) : gr.bitmap.draw v[cr,pt], bc[v[cr,vl]], vx, vy : nv =cr : cr++
  until c$=""
endif
if len(ln$[7]) : cr =1
  do
    c$ =word$(ln$[7], cr)
    if len(c$) then p[cr,vl] =val(c$) : gr.bitmap.draw p[cr,pt], dos[bdos], pqx, pqy : np =cr : cr++
  until c$=""
endif
for c=1 to 7
  if len(ln$[7+c]) : cr =1
    do
      c$ =word$(ln$[7+c], cr)
      if len(c$)
        n[c]++ : co[c,n[c],vl] =val(c$) : c$ =word$(ln$[7+c], cr+1) : co[c,n[c],vu] =val(c$) : cr+=2
        if co[c,n[c],vu] then btmp =bc[co[c,n[c],vl]] else btmp =dos[bdos]
        gr.bitmap.draw co[c,n[c],pt], btmp, 2+(c-1)*114, gy+(n[c]-1)*inc
      endif
    until c$=""
  endif
next
array.delete ln$[]
return
